
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>DataTable.NewRow 内存泄漏问题 / iVAN</title>

    <meta name="description" content="DataTable.NewRow 内存泄漏问题 昨天做了一个自动生成Insert 语句的小工具,今天测试发现存在严重的内存泄漏问题,代码看了好几遍,没发现问题.后来用 .Net Memory Profiler 跟踪(跟踪方法见 用 .NET Memory Profiler 跟踪.net 应用内存使用情况--基本应用篇) 发现有数千个DataRow 没有释放,最后定位是DataTable.NewRow 的问题. 先看一下有问题的代码 public DataRow GetNextRow() { if (_DataReader.Read()) {">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">DataTable.NewRow 内存泄漏问题</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>　　昨天做了一个自动生成Insert 语句的小工具，今天测试发现存在严重的内存泄漏问题，代码看了好几遍，没发现问题。后来用 .Net Memory Profiler 跟踪（跟踪方法见 用 .NET Memory Profiler 跟踪.net 应用内存使用情况--基本应用篇) 发现有数千个DataRow 没有释放，最后定位是DataTable.NewRow 的问题。</p>
<p>　　先看一下有问题的代码</p>
<p>public DataRow GetNextRow()<br />
<br />{<br />
<br /> if (_DataReader.Read())<br />
<br /> {<br />
<br /> DataRow row = _SchemaTable.NewRow();<br />
<br /> for<br />
each (DataColumn col in _SchemaTable.Columns)<br />
<br /> {<br />
<br /> row[col.ColumnName] = _DataReader[col.ColumnName];<br />
<br /> }<br />
<br /> return row;<br />
<br /> }<br />
<br /> else<br />
<br /> {<br />
<br /> return null;<br />
<br /> }<br />
<br />}</p>
<p>　　这段代码我希望通过SqlDataReader 对象 _DataReader 来获取一行数据。_SchemaTable 是一个DataTable 对象，这个DataTable对象没有记录，只存放Table 的Schema。乍一看好像没有什么问题，_SchemaTable.NewRow() 是根据_SchemaTable 的列信息生成一个新行，但这个新行并没有调用 _SchemaTable.Rows.Add 方法加入到_SchemaTable 表中，一般认为这个新生成的 DataRow 在使用完后会被自动回收，但实际情况并不是这样，只要_SchemaTable 不释放，_SchemaTable.NewRow 生成的所有DataRow都无法释放。</p>
<p>　　网上搜了一下，有一位仁兄和我遇到同样问题 Table NewRow() Causes Memory Leak</p>
<p>　　被采纳的解决意见是这样的：</p>
<p>　　DataTable.NewRow() adds the created row to the DataTable's RecordManager. I am not entirely sure why this happens, but this is why it is not freed by the GC.</p>
<p>　　It appears that there are only two ways to get rid of the DataRow:</p>
<p>Add it to the table, then delete it. Call DataTable.Clear().<br />
<br />　　也就是说DataTable.NewRow 方法创建的DataRow 对象会被加入到DataTable 的 RecordManager 中，我们可以通过以下两种方法来释放掉它：</p>
<p>　　1. 通过 DataTable.Rows.Add 方法将这一行加入到DataTable 中，然后再通过 DataTable.Rows.Remove 方法删除它。</p>
<p>　　2. 调用 DataTable.Clear() 方法释放。</p>
<p>　　由于我这个应用中数据表只存放架构信息，始终是空表，所有我采用了第2种方法。加入 _SchemaTable.Clear() 这一句后内存泄漏问题解决。</p>
<p>　　改正后的代码如下：</p>
<p>public DataRow GetNextRow()<br />
<br />{<br />
<br /> if (_DataReader.Read())<br />
<br /> {<br />
<br /> DataRow row = _SchemaTable.NewRow();<br />
<br /> foreach (DataColumn col in _SchemaTable.Columns)<br />
<br /> {<br />
<br /> row[col.ColumnName] = _DataReader[col.ColumnName];<br />
<br /> }<br />
<br /> _SchemaTable.Clear();<br />
<br /> return row;<br />
<br /> }<br />
<br /> else<br />
<br /> {<br />
<br /> return null;<br />
<br /> }<br />
<br />}</p>
<p>　　不好意思，上面代码还是有问题， _SchemaTable.Clear() 后DataRow 里面的数据都会被清空，必须在调用完新生成的DataRow后再 _SchemaTable.Clear 才行，特此更正。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:54:20</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/name/" title="name">name</a>, <a href="https://www.iamivan.net/tag/%e8%bf%99%e4%b8%aa/" title="这个">这个</a>, <a href="https://www.iamivan.net/tag/%e9%80%9a%e8%bf%87/" title="通过">通过</a>, <a href="https://www.iamivan.net/tag/%e5%86%85%e5%ad%98%e6%b3%84%e6%bc%8f/" title="内存泄漏">内存泄漏</a>, <a href="https://www.iamivan.net/tag/%e5%8a%a0%e5%85%a5/" title="加入">加入</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>DataTable.NewRow 内存泄漏问题的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN21Z7M.html" rel="bookmark">艾伟&lowbar;转载：DataTable&period;NewRow 内存泄漏问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				昨天做了一个自动生成Insert 语句的小工具,今天测试发现存在严重的内存泄漏问题,代码看了好几遍,没发现问题.后来用 .Net Memory Profiler 跟踪(跟踪方法见 用 .NET Memory Profiler 跟踪.net 应用内存使用情况--基本应用篇) 发现有数千个DataRow 没有释放,最后定位是DataTable.NewRow 的问题. 先看一下有问题的代码 public DataRow GetNextRow(){if (_DataReader.Read()) { Da			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/gpk0Z5z.html" rel="bookmark">VC&plus;&plus;的win32小程序内存泄漏，求高手解答</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 VC++的win32小程序内存泄漏,求高手解答 做的一个简单的交通模拟小程序,用三个定时器分别产生 汽车处理消息,红绿灯更换消息和汽车随机产生消息.但是最后程序内存越跑越大.求高手解答.http://download.csdn.net/detail/hdwbdbsm/6724747这个是程序的下载地址,求高手.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9bBkROM.html" rel="bookmark">Android 内存泄漏总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android 内存泄漏总结 内存管理的目的就是让我们在开发中怎么有效的避免我们的应用出现内存泄漏的问题.内存泄漏大家都不陌生了,简单粗俗的讲,就是该被释放的对象没有释放,一直被某个或某些实例所持有却不再被使用导致 GC 不能回收.最近自己阅读了大量相关的文档资料,打算做个 总结 沉淀下来跟大家一起分享和学习,也给自己一个警示,以后 coding 时怎么避免这些情况,提高应用的体验和质量. 我会从 java 内存泄漏的基础知识开始,并通过具体例子来说明 Android 引起内存泄漏的各种原因,以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5Q2Ap.html" rel="bookmark">C&num; DataTable&period;NewRow 方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				DataTable.NewRow 方法         Creates a new DataRow with the same schema as the table. Namespace:  System.Data Assembly:  System.Data (in System.Data.dll) Return Value Type: System.Data.DataRow         A DataRow with the same schema as the DataTable.  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qMqWqaz.html" rel="bookmark">精华阅读第 13 期 &vert;常见的八种导致 APP 内存泄漏的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本期是移动开发精英俱乐部的第13期文章,都是以技术为主,所以这里就不过多的进行赘述了,我们直接看干货内容吧!本文系ITOM管理平台OneAPM整理. 实际项目中的MVVM(积木)模式–序章 导读:开篇之前,先贴上以该设计模式为基础的iOSAPP的App Store地址:https://appsto.re/cn/neiscb.i 这个项目通过笔者所要讲的设计模式,三个人在同时需要忙于其他项目维护的情况下,从开工到上架,前前后后加起来用了一个月的时间.因此,在保证项目质量的前提下,敏捷开发以及如何保			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/yMA6eKp.html" rel="bookmark">mfc-MFC中视频流内存泄漏问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 MFC中视频流内存泄漏问题 void CHLDlg::OnBnClickedOpen(){ // TODO: 在此添加控件通知处理程序代码 CFileDialog dlg(TRUENULLNULLNULLNULL); pCapture = NULL; if(dlg.DoModal()==IDOK)// { PathName = dlg.GetPathName(); FileName = dlg.GetFileName(); } else { return; } c=(LPCSTR)Pa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM11R5M.html" rel="bookmark">关于ie的内存泄漏与&amp;amp&semi;&num;106avascript内存释放</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     最近做一个公司的业务系统,公司要求能尽可能的与c/s近似,也就是如c/s一样,点击文本框可以弹出此项目的相关内容,进行选择输入.     我使用了弹出窗口,然后在子窗口双击选中项目,把选中的值返回给父窗体.     在系统做完了之后,在客户使用的过程,由于客户使用的是512m的内存配置,所以在打开了30--40个窗体之后,ie的虚拟内存占用量达到近200m,从而使系统变慢,javascript的运行也变慢了.       在google搜了一下之后,才知道可能是由于ie的内存泄漏引起的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9MxOnBb.html" rel="bookmark">关于ie的内存泄漏与javascript内存释放</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				javascript      最近做一个公司的业务系统,公司要求能尽可能的与c/s近似,也就是如c/s一样,点击文本框可以弹出此项目的相关内容,进行选择输入.     我使用了弹出窗口,然后在子窗口双击选中项目,把选中的值返回给父窗体.     在系统做完了之后,在客户使用的过程,由于客户使用的是512m的内存配置,所以在打开了30--40个窗体之后,ie的虚拟内存占用量达到近200m,从而使系统变慢,javascript的运行也变慢了.       在google搜了一下之后,才知道可能是由			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/apXkNyM.html" rel="bookmark">linux下创建线程内存泄漏&comma;php的json</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这次还是把遇到的几个问题整理一下,希望再遇到的同学能轻松解决.另外最近博客的feeds延迟更新的原因也会一起说明一下. 1.linux下创建线程导致内存泄漏 今天在外网发布了一个server之后,用top发现virt的使用量一直在涨,而且一次涨8m.于是可以断定有内存泄漏了,经过排查,最终确定原因出在多线程的问题上: 代码如下: 1 2 3 4 5 6 pthread_t thread_id; int ret=pthread_create(&amp;thread_id, NULL, flush_th			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvvWWM.html" rel="bookmark" class="title">ASP设计常见问题及解答精要&lpar;1&rpar;</a>
					<div>
						解答|设计|问题 作为微软推出的网页与数据库解决方案,ASP由于有微软得天独厚的操作系统等技术后盾支持,因此得到了迅速的发展,并且正受到越来越多的欢迎,在目前在电子商务网站的建设中有很多都使用ASP来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b27ZrM.html" rel="bookmark" class="title">你了解自己的网站吗</a>
					<div>
						在美国,为网站提供性能监测服务已是一个成熟的产业.有越来越多的网站向第三方性能监测机构寻求援助. 3年前的感恩节晚上, 一位在美国某大型电子购物网站 上购物的美国用户遇到了麻烦.他花了半个多小时在这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxkKBb.html" rel="bookmark" class="title">利用百度快照投诉的后遗症</a>
					<div>
						今天下午逛以前文章的时候,看见这样一篇文章&lt;实战利用百度快照投诉 恢复最新百度快照&gt;,里面的内容写得很好,但是文章其实只写了关于投诉所需要主要的事项,并没有写投诉能够带来的后遗症! 百度投 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElQL6z.html" rel="bookmark" class="title">用Vector进行深层复制</a>
					<div>
						下面让我们复习一下本章早些时候提出的Vector例子.这一次Int2类是可以克隆的,所以能对Vector进行深层复制:   //: AddingClone.java // You must go th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE84Nb.html" rel="bookmark" class="title">浅析Linux中的时间编程和实现原理（二）硬件和GLibC库的细节</a>
					<div>
						引子 熟悉了基本的编程方法之后,我们的兴趣就在于,计算机如何实现这一切的呢?在那些应用层 API 和底层系统硬件之间,操作系统和库函数究竟做了些什么? 首先看下 Linux 时间处理的一般过程: 图  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ywKvz.html" rel="bookmark" class="title">Delphi与DirectX之DelphiX&lpar;55&rpar;&colon;TDIB&period;DoMosaic&lpar;&rpar;&semi;</a>
					<div>
						本例效果图: 代码文件: unit Unit1; interface uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7YZZM.html" rel="bookmark" class="title">js控制滚动条缓慢滚动到顶部</a>
					<div>
						&lt;html&gt; &lt;head&gt; &lt;script type=&quot;text/javascript&quot;&gt; var currentPosition,timer; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAO96b.html" rel="bookmark" class="title">Word2013如何设置图片环绕</a>
					<div>
						  设置图片环绕的步骤如下: 步骤一:一些Word应用者最常用的办法就是通过&quot;插入&quot;--&quot;图片&quot;--&quot;来自文件&quot;功能在Word文档中插入图片 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4JZ9p.html" rel="bookmark" class="title">Python中Continue语句的用法的举例详解</a>
					<div>
						  这篇文章主要介绍了Python中Continue语句的用法的举例详解,是Python入门中的基础知识,需要的朋友可以参考下 Python continue语句返回while循环的开始.Contin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24rlkp.html" rel="bookmark" class="title">XP用户如何摆脱SP2的通知</a>
					<div>
						Windows XP SP2是基于Windows XP 一款软件服务包,是 Microsoft 有史以来发布的最为重要的服务包之一.它提供了对病毒.黑客和蠕虫的更好保护,并且内置Windows 防火墙 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z428xNM.html" rel="bookmark" class="title">php实现根据IP地址获取其所在省市的方法&lowbar;php实例</a>
					<div>
						根据现有IP地址获取其地理位置(省份,城市等)的方法 function GetIpLookup($ip = ''){ if(empty($ip)){ return '请输入IP地址'; } $res  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAALvM.html" rel="bookmark" class="title">InputStream 的read&lpar;byte&lbrack;&rsqb; d&rpar;方法读取内容出现重复读取，这是为什么？</a>
					<div>
						问题描述 InputStream的read(byte[]d)方法读取内容出现重复读取,这是为什么? 解决方案 解决方案二:有没有用到skip()方法?如果用到了,实际上是skip的问题解决方案三:你是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlmokb.html" rel="bookmark" class="title">gc-JVM中奇怪的Full GC， 大家帮忙分析下</a>
					<div>
						问题描述 JVM中奇怪的Full GC, 大家帮忙分析下 下面的gc log中的full gc是怎么触发的,理解不了,请大神看看- 2015-02-03T14:40:12.029+0800: 470. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamqNnb.html" rel="bookmark" class="title">Android中Handler Runnable与Thread的区别详解</a>
					<div>
						转自: http://www.codeceo.com/article/android-handler-runnable-thread.html Android中Handler可以异步控制Runnabl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVPe6b.html" rel="bookmark" class="title">java class生成jar包&lpar;转&rpar;</a>
					<div>
						  进入dos操作符窗口cd进入要打成jar包的class文件所有文件夹目录jar cvf [生成jar的名称.jar] [列出class文件] //若有多个,以空隔隔开 如:一.操作零散的单个或几个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVZw5b.html" rel="bookmark" class="title">WCF的Binding模型之五：绑定元素（Binding Element）</a>
					<div>
						在上面的内容中,先后介绍了信道.信道管理器.信道监听器和信道工厂.从对象的创建来讲,信道管理器是信道的创建者.说的再具体点,客户端的信道通过信道工厂创建,服务端的信道通过信道监听器创建.但是信道工厂和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRmKBz.html" rel="bookmark" class="title">hotswap 用户手册</a>
					<div>
						关于hotswap(该补丁的网址http://ssw.jku.at/dcevm/) Hotswap  是一个允许在运行状态下无限制的修改加载类文件的Java虚拟机补丁.当前java虚拟机的动态加载机制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWEAmp.html" rel="bookmark" class="title">水晶报表-怎么设置CrystalReportViewer导出报表时只能选择导出PDF？</a>
					<div>
						问题描述 怎么设置CrystalReportViewer导出报表时只能选择导出PDF? 客户现在不想要导出word和Exel等功能,只想保留导出PDF功能,怎么样设置才能在选择导出时只能导出PDF吗?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkB3Db.html" rel="bookmark" class="title">国内微博市场遭遇成长性烦恼</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 尽管智能手机成长迅速,但其却未带来微博用户的大量增长.&quot;微博等产品最怕的就是盛极而衰的自由落体般突然跳水.&quot;B2C网站兰亭集势创始人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NjBqz.html" rel="bookmark" class="title">java-简单多线程运行结果不正确</a>
					<div>
						问题描述 简单多线程运行结果不正确 class TestThread1 extends Thread { public void run() { for(int i=0;i&lt;10;i++) {  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQe1Dp.html" rel="bookmark" class="title">在使用PDFNET&period;dll 的时候出现水印</a>
					<div>
						问题描述 我在用PDFNET.dll这个DLL把PDF文档转换成XPS但是转换好了以后xps出现水印有什么好的办法解决吗? 解决方案 解决方案二:很简单啊,用ultraedit工具,查找水印中的这几个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My36VEz.html" rel="bookmark" class="title">关于jdk环境变量配置的问题</a>
					<div>
						问题描述 关于jdk环境变量配置的问题 开发java项目必须要jdk配置系统变量吗?我电脑上的配置的jdk系统变量丢了,java项目依然能运行,只是在cmd输入java -version一直说不是内部 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeJaOb.html" rel="bookmark" class="title">java分页，上一页，下一页，123页这种</a>
					<div>
						问题描述 java分页,上一页,下一页,123页这种 求java分页,分成1.2.3.4.5页类型的和上一页下一页结合,谢谢!!!,想研究一下!!!已经会上一页下一页了!!! 解决方案 Spring+ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94Q3Rb.html" rel="bookmark" class="title">年度盘点｜AI科技评论做过的那些CV公开课</a>
					<div>
						2016年是雷锋网(公众号:雷锋网)-AI科技评论非常重要的一年,我们围绕人工智能做了一系列的业界,学界,开发者报道,也请了一系列导师大牛过来给我们做相关的技术公开课,在给这些导师大牛提供了一个绝佳展 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z7qqz.html" rel="bookmark" class="title">对象-&commat;C语言大神：此题不用C&plus;&plus;能做吗？求算法思路？？【不要求代码】</a>
					<div>
						问题描述 @C语言大神:此题不用C++能做吗?求算法思路??[不要求代码] 求:同日出生的人的总个数,请使用面向对象的方法,找出若干同学中,生日相同的学生总数. 提示: 1.定义类表示日期,包含私有属 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RwwAz.html" rel="bookmark" class="title">Wordpress：巧用条件语句为博客减压</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 Wordpress博客程序是当前最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEV6nM.html" rel="bookmark" class="title">如何写一个ADO&period;net的通用方法，用来运行SQL获取某一张表的记录数</a>
					<div>
						问题描述 我想采用ADO.NET来写一个方法:实现可以通过传入连接串,SQL语句获得SQL语句查询结果的记录数,方法形式如下:publicstaticintgetExesqlCount(Strings ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBOR6z.html" rel="bookmark" class="title">给力的张家界营销 回顾网络营销事件</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 近几年的张家界,在中国网络上可谓风 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJ7Zkp.html" rel="bookmark" class="title">回顾百度发展细节 CEO李彦宏揭秘其成功秘诀</a>
					<div>
						[硅谷网7月27日收拾]有人说,中国任务经理人的创业明显并非仅仅想 获取更多的财富,自我价值的完成也很重要.在这一点上,李彦宏就是最棒的注脚从李彦宏决然抛弃外国公司丰盛待遇和期权,回国创建了百度至今, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgxoAM.html" rel="bookmark" class="title">Java 笔记09</a>
					<div>
						Module 10:I/O流(java如何实现与外界数据的交流) Input/Output:指跨越出了JVM的边界,与外界数据的源头或者目标数据源进行数据交换.               输出    ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
